# coding=gbk
from langchain.vectorstores import Chroma
from langchain.embeddings.huggingface import HuggingFaceEmbeddings
import os

#  Embeddings
embeddings = HuggingFaceEmbeddings(model_name="/mnt/sdb/zhaoyuan/rongrunxiang/acge_text_embedding")


# ݿ־û·
persist_directory = 'data_base/vector_db/chroma'

# ݿ
vectordb = Chroma(
    persist_directory=persist_directory,
    embedding_function=embeddings
)

from LLM import ChatGLM_LLM
modelPath = "/mnt/sdb/zhaoyuan/rongrunxiang/glm-4-9b-chat"
llm = ChatGLM_LLM(model_path = modelPath)
llm.predict("˭")

from langchain.prompts import PromptTemplate

#  Prompt ģ
template = """û⣬ṩҵӦ֪ʶݴ˴һʺ3-6СĻ汾ıȤ
{context}
: {question}
ı:"""

#  LangChain ķʵһ Template 󣬸ö context  question ʵʵʱᱻĵƬκû
QA_CHAIN_PROMPT = PromptTemplate(input_variables=["context","question"],template=template)

from langchain.chains import RetrievalQA

qa_chain = RetrievalQA.from_chain_type(llm,retriever=vectordb.as_retriever(),return_source_documents=True,chain_type_kwargs={"prompt":QA_CHAIN_PROMPT})

# ʴشЧ
question = "ʲôǲ鶯"
result = qa_chain({"query": question})
print("ʴش question Ľ")
print(result["result"])

if "source_documents" in result:
    print("\nҵĵƬΣ")
    for doc in result["source_documents"]:
        print(doc)  # ĵƬֱӿɴӡģҪʵʽ


#  LLM شЧ
result_2 = llm(question)
print("ģͻش question Ľ")
print(result_2)
